package com.codepath.utils;

import android.os.AsyncTask;

public class AsyncSimpleTask extends AsyncTask<Void, Void, Void> {
    private AsyncSimpleTaskHandler handler;

    public AsyncSimpleTask(AsyncSimpleTaskHandler handler) {
        this.handler = handler;

        super.execute();
    }

    @Override
    protected Void doInBackground(Void... voids) {
        this.handler.doInBackground();

        return null;
    }

    @Override
    protected void onPostExecute(Void arg) {
        this.handler.onPostExecute();
    }

    public static abstract class AsyncSimpleTaskHandler {
        public abstract void doInBackground();
        public void onPostExecute() {}
    }
}
